import std;

// Constants.
const unsigned int kPadSquare   = 0x7FFF;
const unsigned int kPadCross    = 0x4000;
const unsigned int kPadTriangle = 0x1000;
const unsigned int kPadCircle   = 0x2000;
const unsigned int kPadR1       = 0x0800;
const unsigned int kPadR2       = 0x0200;
const unsigned int kPadStart    = 0x0008;
const unsigned int kPadLeft     = 0x0080;
const unsigned int kPadDown     = 0x0040;
const unsigned int kPadUp       = 0x0010;
const unsigned int kPadRight    = 0x0020;
const unsigned int kHarnessInfo = 1023;

// Global variable that holds the status of pad 0 the last time it was polled.
// Poll/Update the gamepad from the harness data.
int PadPoll(float4 vuMem[])
{
  return int(vuMem[kHarnessInfo].w);
}

// Check if a pad button is pressed.
bool PadPressed(const unsigned int pad, int padInfo)
{
  unsigned int mask = pad;

  // ToDo: Explain why...
  if (pad == kPadSquare)
    mask += 1;
  
  return (padInfo & mask) == 0;
}
