#ifndef MAT44_H
#define MAT44_H

struct Vec4;

struct Mat44
{
	float elements[4 * 4];

  Mat44()
  {
  }
  
  Mat44(const Mat44 &m)
  {
    for (int i = 0; i < 4 * 4; ++i)
      elements[i] = m.elements[i];
  }

  void LoadIdentity()
  {
    for (int i = 1; i < 4 * 4; ++i)
      elements[i] = 0.0f;

    elements[0 + 0 * 4] = 1.0f;
    elements[1 + 1 * 4] = 1.0f;
    elements[2 + 2 * 4] = 1.0f;
    elements[3 + 3 * 4] = 1.0f;
  }

  void SetRow(int row, const Vec4 &v)
  {
	  elements[row + 0 * 4] = v.x;
	  elements[row + 1 * 4] = v.y;
	  elements[row + 2 * 4] = v.z;
	  elements[row + 3 * 4] = v.w;
  }

  const Vec4 GetRow(int row)
  {
	  Vec4 v;

	  v.x = elements[row + 0 * 4];
	  v.y = elements[row + 1 * 4];
	  v.z = elements[row + 2 * 4];
	  v.w = elements[row + 3 * 4];

	  return v;
  }
};

#endif // MAT44_H
